﻿CKEDITOR.plugins.add('audio',
{
    init: function(editor)
    {
        var avidtor=function(_upload){
            var filename=_upload.replace(/(\\+)/g,"#");
            var one=filename.split("#");
            var two=one[one.length-1];
            var three=two.split(".");
            var last=three[three.length-1];
            var tp ="mp3,wma,aac";
            var rs=tp.indexOf(last);
            if(rs>=0){
                return true;
            }
            else{
                alert('音频文件格式不正确！');
            }

        }

        var SetFileField=function(){
           var fileVlue=document.getElementById('status_view').innerHTML;
            alert(fileVlue);
        }

        var pluginName = 'audio';
        editor.addCommand(pluginName, new CKEDITOR.dialogCommand(pluginName));
        editor.ui.addButton('audio',
        {
                label: '上传音频',
				command: pluginName,
				icon: CKEDITOR.plugins.getPath('audio') + 'music.png'
        });
        // define dialog property
        CKEDITOR.dialog.add(pluginName, function (editor) {
           return {
               title:'上传音频',
               minWidth : 390,
               minHeight : 130,
               contents:[
                   {    // tab1(获取链接)
                       id : 'tab1',
                       label : '获取链接',
                       title : '获取链接',
                       elements:[{
                          type :'hbox',
                          widths :['20%','80%'],
                          children:[{
                               type:'select',
                               label:'协议',
                               id:'protocol',
                               'default':'<其他>',
                               items:[['http://'],['https://'],['ftp://'],["news://"],["<其他>"]]
                           },
                           {
                               type:'text',
                               label:'源文件',
                               id:'targetFile'
                           }]
                          
                       },
                       {
                         type :'vbox',
                         children:[{
                             id:'search',
                             type:'button',
                             label:"浏览服务器",
                             filebrowser:'tab1:targetFile',
                             onClick:function(){
                               var finder = new CKFinder();
                               finder.BasePath = '../ckedt/upload/';
                               finder.popup(600,480);
                               var file=finder.getSelectedFile();
                               console.log(file);
                             }

                         }]
                       }


                       ]
                   },
                   {    // tab2(上传音频)
                        id : 'tab2',
                        label : '上传音频',
                        title : '上传音频',
                         filebrowser : 'fileId',
                        elements:[{
                           type:'vbox',
                           children:[{
                               id : 'upload',
                               type : 'file',
                               label : '上传文件',
                               size : 35,
                               onChange:function(){
                                   var d = this.getDialog();
                                   var _upload=d.getContentElement('tab2','upload').getValue();
                                   avidtor(_upload);
                                    }
                           },
                           {
                                   type : 'fileButton',
                                   id : 'fileId',
                                   target : 'tab1:targetFile',
                                   label : '上传到服务器',
                                   'for' : [ 'tab2', 'upload' ],
                                    action : 'QuickUpload',
                                    filebrowser : {
                                        action :'QuickUpload',
                                        onSelect : function(fileUrl,data) {
                                             if(!avidtor(fileUrl)){
                                               alert('上传失败');
                                               return false;
                                             }
                                            console.log('Successfully uploaded:' + fileUrl);
                                            alert('上传成功！');
                                            var t=this.getDialog();
                                            t.getContentElement('tab1','targetFile').setValue(fileUrl);
                                        }
                                    }
                           }

                           ]
                       }]
                    },


               ],
                       onOk:function(){
                           _src = this.getContentElement('tab1', 'targetFile').getValue();
                            if(_src=='' && avidtor(_src) ){
                               return false;
                            }

                           this.element = editor.document.createElement('audio');
                           this.element.setAttribute( 'src', _src );
                           this.element.setAttribute( 'controls','controls' );
                           editor.insertElement(this.element);

                       }
               
           };
        });
    }

});

